function sp = addcombo (sp, label, keys)

%@SPIX/ADDCOMBO  defines a combination of keys in a @spix
%
%Modified: 9 Aug 03

%  9 Aug 03, by Giuseppe Bertini, based on addgroup

if nargin > 2
   ks = parsegrouping (sp.k, keys);
   if isempty(ks), error ('none of the requested keys exists'); end
   disp ([num2str(length(ks)) ' keys']);
else
   disp ('all the currently "included" keys')
   ks = sp.inkeys;
end

sset = lbl2idx (sp.combos, label);
if sset
   disp ('redefining an existing combo');
else
   disp ('creating a new combo');
   sset = sp.ncombos + 1;
   sp.combos(sset).label = label;
   sp.ncombos = sset;
end

sp.combos(sset).keys = ks;