function sp = addgroup (sp, label, keys)

%ADDGROUP  defines a group of keys in a @spix
%
%Modified: 30 May 03

% 26 Apr 03, by Giuseppe Bertini
% 30 May 03: lotsa fixes

if nargin > 2
   ks = parsegrouping (sp.k, keys);
   if isempty(ks), error ('none of the requested keys exists'); end
   disp ([num2str(length(ks)) ' keys']);
else
   disp ('all the currently "included" keys')
   ks = sp.inkeys;
end

sset = lbl2idx (sp.groups, label);
if sset
   disp ('redefining an existing group');
else
   disp ('creating a new group');
   sset = sp.ngroups + 1;
   sp.groups(sset).label = label;
   sp.ngroups = sset;
end

sp.groups(sset).keys = ks;