function sset = parser (branch, units)

% returns a valid subset of integers
% unit subsets and key groups can be processed this way

switch class(units)
case 'char'
   switch units
   case 'all'
      sset = 1:sp.nunits;
   case 'first'
      sset = 1;
   case 'last'
      sset = sp.nunits;
   case 'none'
      sset = [];
   otherwise
      setid = lbl2idx (sp.subsets, units);
      if setid
         sset = sp.subsets(setid).units;
      else
         sset = lbl2idx (sp.info, units);
         if ~sset, error('could not find label'), end
      end
   end
case 'double'
   warning(unitrange(sp, units));
   sset = find (ismember(1:sp.nunits, units));
otherwise
   error('bad parameter');
end