function sset = parsesubset (sp, units)

%SPIX/PRIVATE/PARSESUBSET
%
%Last modified: 8 Aug 03

%  8 aug 03: if...elseif replaces switch block to allow use of isnumeric

if isa (units, 'char')
   switch units
      case 'all'
         sset = 1:sp.nunits;
      case 'first'
         sset = 1;
      case 'last'
         sset = sp.nunits;
      case 'none'
         sset = [];
      otherwise
         setid = lbl2idx (sp.subsets, units);
         if setid
            sset = sp.subsets(setid).units;
         else
            sset = lbl2idx (sp.info, units);
            if ~sset, error('the requested unit does not exist'), end
         end
   end
elseif isnumeric (units)
   sset = find (ismember(1:sp.nunits, units));
   if isempty (sset), error ('none of the requested units exist'); end
   if any(units > sp.nunits | units < 1), warning ('some of the requested units do not exist'); end
else
   error('bad parameter');
end