function sp = restoreunits (sp, units)

%@SPIX/RESTOREUNITS
%
%   SP = RESTOREUNITS(SP,UNITS)  restores previously excluded UNITS in
%   SP; UNITS can be a unit label, a set of unit labels (in a cell
%   array of strings), one of 'none' 'all' 'first' 'last', or a
%   numeric array specifying the ordinal numbers of the units to be
%   restored. No errors or warnings are issued if any or all of the
%   requested units were already included.
%
%Last modified: 21 Aug 03

uni = parsegrouping (sp.info, units);
disp ('#######################################');
disp (sprintf ('%4d units successfully restored', length(setdiff(uni,sp.inclunits))));
sp.inclunits = union (sp.inclunits, uni);
dispinclunits(sp)

