function sp = selectunits (sp, units)

%@SPIX/SELECTUNITS
%
%   SP = SELECTUNITS(SP,UNITS)  selects UNITS from SP for use in
%   subsequent analyses; in other words, all units in SP that are not
%   specified in UNITS will be excluded. First, the program checks to
%   see if UNITS is a subset label, in which case the corresponding
%   units will be selected. Otherwise, UNITS can be a unit label, a
%   set of unit labels (in a cell array of strings), one of 'none'
%   'all' 'first' 'last', or a numeric array specifying the ordinal
%   numbers of the units to be selected.
%
%Last modified: 21 Aug 03

disp ('#######################################');
if ischar(units)
   for i=1:sp.nsubs
      if strcmp (sp.subsets(i).label, units)
         sp.inclunits = sp.subsets(i).units;
         disp (['subset ''' units ''' selected']);
         dispinclunits (sp);
         return
      end
   end
end
sp.inclunits = parsegrouping (sp.info, units);
dispinclunits (sp);
