function [frates, uni, grp] = trialfiringrate (sp, win, binsize, varargin)

%@SPIX/TRIALFIRINGRATE   trial-by-trial firing rates from a @spix object
%
%  to get help type:
%  >>help trialfiringrate
%
%Last modified: 18 Aug 03

% 24 dec 02: last unnoted changes
% 16 apr 03: help text
% 17 Apr 03: call to truncspm
% 23 Apr 03: call to trialset replaces findyestrials
% 18 Aug 03: complete change of concept!

[chunk uni, grp] = spikematrix (sp, win, binsize, varargin{:});
[spmat, instances, winsize, numofbins] = truncspm (chunk, binsize);
spmat = reshape(spmat, instances, binsize, numofbins);
frates = squeeze (sum (spmat, 2) / binsize * 1000);
