function modify (source_filename, target_filename, rule, command)

% modify.m
% Last modified: 13 Jun 99

UINT8  = 1;
UINT16 = 2;
UINT32 = 4;

fr = openfile (source_filename, 'r');
fw = openfile (target_filename, 'w');

trial=0;
while 1
   % read the first header entry and use it to test for eof
   % and for file integrity (this value should always be 26)
   header_len = fread (fr, 1, 'uint16');
   if feof (fr)
      break % end of file
   elseif header_len ~= 26
      error ('header size mismatch; corrupted data file?');
   end
   
   trial = trial + 1;
   
   con = 1 + fread (fr, 1, 'uint16'); % base 0 !!!
   rep = 1 + fread (fr, 1, 'uint16'); % base 0 !!! 
   blo = 1 + fread (fr, 1, 'uint16'); % base 0 !!!
   rel = fread (fr, 1, 'uint16'); % base 1 !!!
   
   tims = fread (fr, 1, 'uint16'); % length in bytes of the time stamp buffer
   cods = fread (fr, 1, 'uint16'); % length in bytes of the encodes buffer
   eogs = fread (fr, 1, 'uint16'); % length in bytes of the eog buffer
   epps = fread (fr, 1, 'uint16'); % length in bytes of the epp buffer
   
	eog = fread (fr, 1, 'uint8' ); % ms between eog samples. set in General Parameters
   khz = fread (fr, 1, 'uint8' ); % data collection sampling rate. idem
   
   typ = fread (fr, 1, 'uint16'); % an attribute of the condition
   exp = fread (fr, 1, 'uint16'); % the argument passed to the response_xxx() function
   res = fread (fr, 1, 'uint16'); % the value returned by the response_xxx() function
   
   % a check for file integrity
   if tims/UINT32 ~= cods/UINT16
      warning ('possible file corruption: timebuf vs. codebuf mismatch');
   end
   
   % buffers
	times  = fread (fr, tims/UINT32, 'uint32');
   codes  = fread (fr, cods/UINT16, 'uint16');
   eogbuf = fread (fr, eogs/UINT16, 'uint16');
   eppbuf = fread (fr, epps/UINT16, 'uint16');

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   if    ((rule.tri == -1) | ~isempty (find (rule.tri == trial))) & ...
         ((rule.con == -1) | ~isempty (find (rule.con == con))) & ...
         ((rule.blo == -1) | ~isempty (find (rule.blo == blo))) & ...
         ((rule.res == -1) | ~isempty (find (rule.res == res))) & ...
         ((rule.typ == -1) | ~isempty (find (rule.typ == typ))) & ...
         ((rule.exp == -1) | ~isempty (find (rule.exp == exp)))
      
      eval (command);
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   fwrite (fw, header_len, 'uint16');
   fwrite (fw, con - 1,    'uint16');
   fwrite (fw, rep - 1,    'uint16');
   fwrite (fw, blo - 1,    'uint16');
   fwrite (fw, rel,        'uint16');
   fwrite (fw, tims,       'uint16');
   fwrite (fw, cods,       'uint16');
   fwrite (fw, eogs,       'uint16');
   fwrite (fw, epps,       'uint16');
   fwrite (fw, eog,        'uint8' );
   fwrite (fw, khz,        'uint8' );
   fwrite (fw, typ,        'uint16');
   fwrite (fw, exp,        'uint16');
   fwrite (fw, res,        'uint16');
   fwrite (fw, times,      'uint32');
   fwrite (fw, codes,      'uint16');
   fwrite (fw, eogbuf,     'uint16');
   fwrite (fw, eppbuf,     'uint16');
   
end
fclose (fw);
fclose (fr);
