function [spm, inst, winsize, numofbins] = truncspm (spm, binsize)

%TRUNCSPM  truncate spikematrix
%   if its width is not a multiple of binsize
%Last modified: 22 Apr 03

[inst, winsize] = size(spm);
extra = rem (winsize, binsize);
if extra
   warning ('time window is not a multiple of binsize;');
   disp (['rightmost ' num2str(extra) 'ms truncated from spike matrix.']);
   winsize = winsize - extra;
   spm (:, winsize+1:end) = [];
   %!spmat = spm (:,1:winsize);
end
numofbins = winsize / binsize;
